TOAD.namespace('app/controllers', function (exports) {
    "use strict";

    var $ = TOAD.$jq,
        register = TOAD.require('@registerController'),
        COLORS = [
            'primary',
            'secondary',
            'success',
            'danger',
            'warning',
            'info',
            'light',
            'dark',
            'white'
        ],
        CHANGE_COLOR_INTERVAL = 10 * 1000

    /**
     * @constructor
     * @param {DOM} el - Elemento DOM da controller
     */
    function HomeController(el) {

        changeBgColor(el)
        setInterval(changeBgColor, CHANGE_COLOR_INTERVAL, el)

        $('pre', el).each(function (i, block) {
            console.log(block)
            hljs.highlightBlock(block)
        })

    }

    /**
     * Altera a classe 'bg-*' do elemento passado aleatoriamente
     * 
     * @private
     * @param {DOM} el - Elemento da controller
     */
    function changeBgColor(el) {
        var $el = $(el),
            colorMax = COLORS.length - 1,
            colorSelected = Math.floor(Math.random() * colorMax),
            twbsClass = 'bg-' + COLORS[colorSelected],
            lastTwbsClass = $el.data('twbs-class')

        $el.removeClass(lastTwbsClass)
        $el.data('twbs-class', twbsClass)
        $el.addClass(twbsClass);
    }

    register({ name: 'home', ctor: HomeController })
})
